unit slider;

interface
uses
  sliderapi,
  vc_engine,
  Windows;

Procedure Create_Slider(ParentWnd:Integer; cfgstr:string);

implementation

Function GetSliderFromWnd(Slider: PSlider; Wnd: Integer): PSlider;
Begin
  If (Slider^.Next_Slider = nil) OR (Slider^.hMainWnd = Wnd) then
    Result := Slider
  Else
    Result := GetSliderFromWnd(Slider^.Next_Slider, Wnd);
End;

function WndProc(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
Var
  Slider : PSlider;
  P : TPoint;
  Buffer: PChar;
  Left, Right, tmp, ret: Integer;
Begin
  WndProc := 0;tmp := 0;
  Slider := GetSliderFromWnd(First_Slider,Wnd);
    Case Msg Of
      WM_ERASEBKGND:
        BitBlt(wParam,0,0,Slider^.Width,Slider^.Height,Slider^.BackDc,0,0,SRCCOPY);
      WM_TIMER:
        PostMessage(Slider^.hMainwnd,WM_UPDATE,0,0);
      WM_CHANGE:
        Begin
          Case Slider^.Mode Of
            Volume:
              Begin
                Change_Volume(Slider^.channel,wParam);
              End;
            Balance:
              Begin
                Change_Balance(Slider^.channel,((100-wParam)*2)-100);
              End;
            Winamp:
              Begin
                PostMessage(hwndWinamp,WM_USER, ((SendMessage(hwndWinamp,WM_USER, 1, 105)*1000)DIV 100)*WParam, 106);
              End;
            WinampVol:
              Begin
                PostMessage(hwndWinamp,WM_USER, Round((255/100)*WParam), 122)
              End;
          End;
        End;
      WM_UPDATE:
        With Slider^ do
        Begin
          Case Slider^.Mode Of
            Volume:
              Begin
                GetVolumeA(channel,Left,Right);
                If (Right>Left) Then
                  Tmp := 100-(Right DIV 655)
                Else
                  Tmp := 100-(Left DIV 655);
              End;
            Balance:
              Begin
                GetVolumeA(channel,left,right);
                If ( Right>Left ) Then
                  Tmp := 100-(Left DIV (Right DIV 100))
                Else
                  Tmp := -100+(Right DIV (Left DIV 100));
                Tmp := (Tmp+100)DIV 2;
              End;
            Winamp:
              Begin
                hwndWinamp := FindWindow('Winamp v1.x',nil);
                If (hwndWinamp=0) Then
                  hwndWinamp := FindWindow('grdampclass',nil);
                If (hwndWinamp<>0) Then
                 Begin
                   ret := SendMessage(hwndWinamp,WM_USER, 0, 104);
                   If ( ret=1 )OR( ret=3 )Then
                     Begin
                       ShowWindow(ClientWnd,SW_SHOW);
                       Tmp := SendMessage(hwndWinamp,WM_USER, 1, 105);
                       Tmp := 100-SendMessage(hwndWinamp,WM_USER, 0, 105)DIV((Tmp*1000) DIV 100);
                     End Else
                       ShowWindow(ClientWnd,SW_HIDE);
                 End Else
                   ShowWindow(ClientWnd,SW_HIDE);
              End;
            WinampVol:
              Begin
                hwndWinamp := FindWindow('Winamp v1.x',nil);
                If (hwndWinamp<>0) Then
                begin
                  ShowWindow(ClientWnd,SW_SHOW);
                  GetVolumeA(1,Left,Right);
                  If (Right>Left) Then
                    Tmp := 100-(Right DIV 655)
                  Else
                    Tmp := 100-(Left DIV 655);
                end else
                  ShowWindow(ClientWnd,SW_HIDE);
              End;
          End;

        If (Inverted) Then
          Tmp := 100-Tmp;
        If ( Typ=Vertical ) then
          hyPos := Round(((Height-2*hoffs-hHeight)/100)*Tmp)+hoffs
        Else
          hxPos := Round(((Width-2*hoffs-hWidth)/100)*Tmp)+hoffs;

        SetWindowPos(ClientWnd,0,hxPos,hyPos,0,0,SWP_NOSIZE+SWP_NOZORDER+SWP_NOSENDCHANGING);
        InvalidateRect(hMainWnd,nil,true);
      End;
    WM_LBUTTONDOWN:
      Begin
        SetCapture(Slider^.Clientwnd);
        PostMessage(Slider^.Clientwnd,WM_MOUSEMOVE,MK_LBUTTON,0);
      End;
    WM_SYSCOMMAND:
      if (wParam = 61536) Then WndProc := 0
      Else
        WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
     WM_DESTROY:
     if Slider^.isDocked then
      begin
        SetWindowLong( Slider^.hMainWnd, GWL_STYLE, WS_CHILD);
        SetParent( Slider^.hMainWnd, 0);
        SetWindowLong( Slider^.hMainWnd, GWL_STYLE, WS_POPUP);
      end;
    Else
      WndProc := DefWindowProc(Wnd,msg,wParam,lParam);
    End;
End;

Function GetSliderFromClient(Slider: PSlider;Wnd: Integer): PSlider;
Begin
  Result := GetSliderFromWnd(Slider, GetParent(Wnd));
End;

function ClientWndProc(Wnd: HWND; Msg: UINT; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
Var
  ps : TPaintStruct;
  fdc : HDC;
  Slider : PSlider;
  P : TPoint;
  R : TRECT;
  //lprc: PRECT;
  lpwp : PWINDOWPOS;
  Value : Integer;
Begin
  ClientWndProc := 0;
  Slider := GetSliderFromClient(First_Slider,Wnd);
    Case Msg Of
      WM_PAINT:
          Begin
            fdc := BeginPaint(Wnd,ps);
              BitBlt(fdc,0,0,Slider^.hWidth,Slider^.hHeight,Slider^.HandDc,0,0,SRCCOPY);
            EndPaint(Wnd,ps);
          End;
      WM_ERASEBKGND:
        BitBlt(wParam,0,0,Slider^.hWidth,Slider^.hHeight,Slider^.HandDc,0,0,SRCCOPY);
      WM_MOUSEMOVE:
        With Slider^ do
        begin
          If ( wParam = MK_LBUTTON ) Then
           begin
             GetCursorPos(P);
             ScreenToClient(hMainWnd,P);
             If ( Typ=Horizontal ) then
              begin
                SetWindowPos(ClientWnd,0,P.X-(hWidth DIV 2),hyPos,0,0,SWP_NOSIZE+SWP_NOZORDER);
                Value := Round((hxPos-hoffs)/((Width-2*hoffs-hWidth)/100));
              end else begin
                SetWindowPos(ClientWnd,0,hxPos,P.Y-(hHeight DIV 2),0,0,SWP_NOSIZE+SWP_NOZORDER);
                Value := Round((hyPos-hoffs)/((Height-2*hoffs-hHeight)/100));
              end;

             InvalidateRect(ClientWnd,nil,false);

             If NOT(Inverted) Then Value := 100-Value;
             PostMessage(hMainWnd,WM_CHANGE,Value,0);
           end;
        end;
      WM_LBUTTONDOWN:
        Begin
          GetWindowRect(Slider^.hMainWnd, R);
          Slider^.xPos := r.left;
          Slider^.yPos := r.top;
          SetCapture(wnd);
        End;
      WM_LBUTTONUP:
        ReleaseCapture;
      WM_WINDOWPOSCHANGING:
        With Slider^ do
        begin
          lpwp := Pointer(lParam);
          If ( Typ=Vertical ) then
           begin
             hyPos := lpwp.y;
             If (hypos < hoffs) then
               hypos := hoffs
             Else
               If (hypos > ((Height-hHeight)-hoffs)) then
                 hypos := (Height-hHeight)-hoffs;
           end
          Else
           begin
             hxPos := lpwp.x;
             If (hxpos < hoffs) then
               hxpos := hoffs
             Else
               If (hxpos > ((Width-hWidth)-hoffs)) then
                 hxpos := (Width-hWidth)-hoffs;
           end;

          lpwp.x := hxPos;
          lpwp.y := hyPos;
        end;
      Else
        ClientWndProc := DefWindowProc(Wnd,msg,wParam,lParam);
    End;
End;

Procedure Create_Slider(ParentWnd:Integer; cfgstr:string);
var
  wc: TWndClass;
  backBMP, handBMP: HBITMAP;
  Slider: PSlider;
  Caption, Md, Flags: String;
  P: tpoint;
begin
  If cfgstr<>'' then
   begin
      New (Slider);
      Slider^.Next_Slider := First_Slider;
      if Slider^.Next_Slider <> nil then
        Slider^.Next_Slider^.Prev_Slider := Slider;
      Slider^.Prev_Slider := nil;
      First_Slider := Slider;

      Caption := GetToken (cfgstr,2);
      Slider^.xPos := Str2Int (GetToken (cfgstr,3));
      If (Slider^.xPos<0) then
        Slider^.xPos := GetSystemMetrics(SM_CXSCREEN) + Slider^.xPos;
      Slider^.yPos := Str2Int (GetToken (cfgstr,4));
      If (Slider^.yPos<0) then
        Slider^.yPos := GetSystemMetrics(SM_CYSCREEN) + Slider^.yPos;
      Slider^.hoffs := Str2Int (GetToken (cfgstr,5));
      backBMP := LoadLSImage(PChar(GetToken (cfgstr,6)),nil);
      handBMP := LoadLSImage(PChar(GetToken (cfgstr,7)),nil);

      If (backBMP=0)OR(handBMP=0) then
      Begin
        Messagebox(0,PChar('Check Step.Rc:'+#13+GetToken (cfgstr,6)+
          #13+'or'+#13+GetToken (cfgstr,7)),'Can''t load image',0);
        DeleteObject(backBMP);
        DeleteObject(handBMP);
        First_Slider := Slider^.Next_Slider;
        Dispose(Slider);Exit;
      End;

      Flags := GetToken (cfgstr,8);

      Slider^.Inverted := Boolean(CheckFlag(Flags,'I'));
      Slider^.Visible := true;
      Slider^.isDocked := true;
      Slider^.GroupID := GetGroup(Flags);

      If ( Boolean(CheckFlag(Flags,'H')) ) Then
        Slider^.Typ := Horizontal
      Else
        Slider^.Typ := Vertical;

      Slider^.Mode := none;
      Md := UpStr(GetToken (cfgstr,9));
      If ( Md= '[VOLUME]' ) Then
        Begin
          Slider^.Mode := Volume;
          If ( UpCase(GetToken (cfgstr,10)[1])='W' ) then
            Slider^.Mode := WinampVol;
          Slider^.channel := Str2Int (GetToken (cfgstr,10));
        End
        Else
        If ( Md= '[BALANCE]' )Then
          Begin
            Slider^.Mode := Balance;
            Slider^.channel := Str2Int (GetToken (cfgstr,10));
          End
          Else
          If ( Md= '[WINAMP]' )Then
            Slider^.Mode := Winamp;

      GetLSBitmapSize(backBMP,Slider^.Width,Slider^.Height);
      GetLSBitmapSize(handBMP,Slider^.hWidth,Slider^.hHeight);

      Slider^.hxPos := (Slider^.Width-Slider^.hWidth) DIV 2;
      Slider^.hyPos := (Slider^.Height-Slider^.hHeight) DIV 2;

      If NOT GetClassInfo(Inst,'LsSliderClass',wc) then
      Begin
        FillChar(wc,sizeof(wc), #0);
        wc.lpfnWndProc := @WndProc;
        wc.lpszClassName := 'LsSliderClass';
        wc.hInstance := Inst;
        RegisterClassA(wc);
      End;

      If NOT GetClassInfo(Inst,'LsSliderHandle',wc) then
      Begin
        FillChar(wc,sizeof(wc), #0);
        wc.lpfnWndProc := @ClientWndProc;
        wc.lpszClassName := 'LsSliderHandle';
        wc.hInstance := Inst;
        RegisterClassA(wc);
      End;

      With Slider^ Do
      begin
        if (ParentWnd=0) then begin
          hMainWnd := CreateWindowExA(
            WS_EX_TOOLWINDOW,'LsSliderClass',nil,WS_POPUP,
            xPos, yPos, Width, Height,0,0,Inst,nil);
          isDocked := false;
        end else
          hMainWnd := CreateWindowExA(
            0,'LsSliderClass',PChar(Caption),WS_CHILD,
            xPos, yPos, Width, Height,ParentWnd,0,
            Inst,nil);

        If hMainWnd=0 then Messageboxa(0,'error creating main window',nil,0);

        If (Boolean(CheckFlag(Flags,'A'))and(ParentWnd = 0)) then
          SetWindowPos(hMainWnd, HWND_TOPMOST, 0, 0, 0, 0, SWP_NOMOVE+SWP_NOSIZE)
        else
          SetWindowPos(hMainWnd, HWND_TOP, 0, 0, 0, 0, SWP_NOSIZE+SWP_NOMOVE);

        If Boolean(CheckFlag(Flags,'B')) then
        Begin
          ShowWindow(hMainWnd,SW_HIDE);
          Visible := false;
        End else
          ShowWindow(hMainWnd,SW_SHOW);

        SetWindowLong(hMainWnd,GWL_USERDATA,$49474541);
        CreateHint(hMainWnd,PChar(Caption));

        ClientWnd := CreateWindowExA(
          0,'LsSliderHandle',nil,WS_CHILD,
          hxPos, hyPos, hWidth, hHeight, hMainWnd,0,
          Inst,nil);
        SetWindowPos(ClientWnd, 0, hxPos, hyPos, hWidth, hHeight, $40);

        If ( mode=none ) Then
        Begin
          ShowWindow(ClientWnd,SW_HIDE);
          Messageboxa(0,'Slider Mode not recognized - Check Spelling',nil,0);
        End;

        If Boolean(CheckFlag(Flags,'T')) Then
        Begin
          SetWindowRgn(hMainWnd,BitmapToRegion(backBMP,RGB(255,0,255),$101010,0,0),True);
          SetWindowRgn(ClientWnd,BitmapToRegion(handBMP,RGB(255,0,255),$101010,0,0),True);
        End;

        If ( Mode=Winamp )OR( Mode=WinampVol ) Then
          Timer := SetTimer(hMainWnd,0,250,nil);

        BackDC := CreateCompatibleDC(GetDC(Slider^.hMainWnd));
        HandDC := CreateCompatibleDC(GetDC(Slider^.ClientWnd));
        SelectObject(BackDc, backBMP);
        SelectObject(HandDc, handBMP);
        DeleteObject(backBMP);
        DeleteObject(handBMP);

        InvalidateRgn(hMainWnd,0,true);
        PostMessage(Slider^.hMainwnd,WM_UPDATE,0,0);
      End;
   end;
End;

end.
